/*
 * InCode - [ iswhat.c ]
 * (c) 2002, J. Weeks
 * jweeks@subdimension.com
 *
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <ctype.h>

#include "iswhat.h"

int isAlpha(char c) {
  char upperC = toupper(c);

  return (upperC >= 'A' && upperC <= 'Z');
}

// NOTE: should decimal be included here or in inputNumber?
// 12345.toString() should be kept in mind
int isNum(char c) {
  return ( (c >= '0' && c <= '9') /*|| c == '.'*/);
}

int isAlphaNum(char c) {
  return(isAlpha(c) || isNum(c) || c == '_');
}

int isSymbol(char c) {
  return !(isAlphaNum(c) || isWhite(c));
}

int isWhite(char c) {
  return (c == ' ' || c == '\n' || c == '\t');
}

int isQuote(char c) {
  return (c == '"' || c == '\'');
}

// shouldn't be needed
int isAddOp(char c) {
  return (c == '+' || c == '-');
}

// shouldn't be needed
int isMulOp(char c) {
  return (c == '*' || c == '/' /* || c == '\\' */ );
}

// also shouldn't be needed (all taken care of by tokenizer)
int isEOL(char c) {
  return (c == ';');
}