/*
 * InCode - [main.c]
 * (c) 2001, J. Weeks
 * jweeks@subdimension.com
 *
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include "main.h"
#include "token.h"
#include "input.h"
#include "output.h"
#include "error.h"
#include "parse.h"
#include "list.h"
#include "compile.h"

int main(int argc, char *argv[])
{
  printf("InCode v0.01, (c)2002\n");
  printf("J. Weeks, CarbonBased\n\n");

  //initOptions(argc, argv);
  inputInit("/dev/stdin");
  outputInit("test.asm");
  //outputInit("/dev/stdout");
  errInit("/dev/stderr");
  tokenInit();

  //inputLookAhead();
  listCreate(&parseTokens);
  listCreate(&stack);
  parseGet(TAny);
  while( inputExists() ) {
    parseLine();
    listPrintAll(&parseTokens);
    /*
    if(flagOptomize) {
      optomize();
      compileLine(&opTok);
    }
    else */ compileLine(&parseTokens);
  }
  // envoke nasm if called for...
  //if(flagAssemble)
  //assemble();

  mainClose();
  return 0;
}

int mainClose(void) {
  // these, I think, are already cleared at the beginning of
  // parseLine and compileLine, but I'll include them here as
  // well, for good measure :)
  listClear(&stack);
  listClear(&parseTokens);
  printf("Closing input/output system\n");
  tokenClose();
  outputClose();
  inputClose();

  return 0;
}