/*
 * InCode - [ output.c ]
 * (c) 2002, J. Weeks
 * jweeks@subdimension.com
 *
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>

#include "output.h"
#include "token.h"

FILE *output;
char *filename;

int outputInit(char *fname) {
  output = fopen(fname, "w");
  filename = fname;
  outputHeader();
  return 0;
}

int outputClose(void) {
  fclose(output);
  return 0;
}

int outputHeader(void) {
  fprintf(output, "; inCode asm output [ %s ]\n", filename);
  fprintf(output, "; iCv 0.01, jjw2002\n\n");
  return 0;
}

int outputString(char *str) {
  fprintf(output, "%s", str);
  return 0;
}

int outputNumber(int num) {
  fprintf(output, "%i", num);
  return 0;
}

int outputTokenName(Token *tok) {
  if(tok->type == TIdentifier) outputString("[");

  switch(tok->type) {
    case TIdentifier:
    case TLabel:
      outputString(tok->name);
      break;
    case TNumericLiteral:
    case TFloatLiteral:
      outputNumber(tok->value);
      break;
  }

  if(tok->type == TIdentifier) outputString("]");
  return 0;
}